var g_HTTPReq;

/*------------------------------------------------------------------------------
 	Module Information
 		- Writer : ġ
 		- Write Date : 2005/05/04
 	Module Prototype
 		- HM_HTTPRequest(url, state_func, frm, method, isXml)
 	Module Description
 		- http request function.
 	Input Parameter Description
 		- url : url
 		- state_func : assign a notify function, use async mode
 		- frm : form object, use form request(get or post)
 		- method : GET, POST
 		- isText : TEXT or XML
 	Return Value
 		- async mode : none
 		- sync mode : http response text.
 	Etc
 	Example
 		-
------------------------------------------------------------------------------*/
function HM_HTTPRequest(url, state_func, frm, method, isXml)
{

	var varResult = "";
	var varMethod = "GET";
	var varAsync = false;
	var varURL = url;

	if( method != null )
		varMethod = method;

	var varBody = null;
	if( frm ) {
		varBody = HM_getBodyData(frm);
	}

    // branch for native XMLHttpRequest object
	if (window.XMLHttpRequest) {
        g_HTTPReq = new XMLHttpRequest();
	} else if (window.ActiveXObject) {
       g_HTTPReq = new ActiveXObject("Microsoft.XMLHTTP");
    } else {
    	return -1;
    }
    
	if( state_func != null )
	{
    	g_HTTPReq.onreadystatechange = state_func;
    	varAsync = true;
    }

	if( varMethod == "POST" && varBody != null ) {
		g_HTTPReq.open(varMethod, varURL, varAsync);
		g_HTTPReq.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
	} else {
		if( varBody )
			varURL += "?" + varBody;
		g_HTTPReq.open(varMethod, varURL, varAsync);
	}

	if( varBody != null && varBody != "" )
		g_HTTPReq.send(varBody);
	else
		g_HTTPReq.send(null);

	//not async.
	if( state_func == null ) {
		if( isXml )
     		varResult = g_HTTPReq.responseXML;
     	else
     		varResult = g_HTTPReq.responseText;
     		
     	g_HTTPReq = null;
    }	

	return varResult;
}

function HM_getBodyData(frm)
{
	var strResult = new String();
	if( frm == null )
		return null;

	var oColl = frm.elements;
	var oObject;
	for( var i = 0; i < oColl.length; i++ )
	{
		oObject = oColl[i];

		if( oObject.type == "checkbox" ) {

			if( oObject.checked == true ) {
				if( strResult.length )
					strResult += "&";
				strResult += oObject.name + "=" + oObject.value;
			}
		} else {
			if( strResult.length )
				strResult += "&";
			strResult += oObject.name + "=" + oObject.value;
		}
	}	
	return strResult;
}

function HM_canRequest()
{
	if( g_HTTPReq != null ) {
		alert("ٸ ۾  Դϴ.\n Ŀ ٽ õ Ͻñ ٶϴ.");
		return false;
	}

	return true;
}

/*
function processReqChange()
{
    // only if req shows "complete"
    if (req.readyState == 4) {
        // only if "OK"
        g_lastHTTPStatus = req.status;
        if (req.status == 200) {
            // ...processing statements go here...
        } else {
            alert("There was a problem retrieving
               the XML data:\n" + req.statusText);
        }
    }
}
*/
